/*
 * Copyright (C) 2021 eichehome
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package server;

import java.io.IOException;
import java.net.*;

/**
 * Hauptklasse des Servers
 *
 * @version 0.0.1
 * @author eichehome
 */
public class MainServer {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try (ServerSocket serverSocket = new ServerSocket(1236)) {
            ClientMessageStore messageStore = new ClientMessageStore();
            while (true) {
                Socket client = serverSocket.accept();
                System.out.println("client connected");
                Thread thread = new ServerHandelClientsThread(client, messageStore);
                System.out.println("Test");
                thread.run();
                messageStore.addThread(thread);

            }
        } catch (Exception ex) {
            System.err.println("Fehler: " + ex);
        }
    }

}
